diff --git a/django/core/management/commands/importcldr.py b/django/core/management/commands/importcldr.py
new file mode 100644
index 0000000..c4a13e6
--- /dev/null
+++ b/django/core/management/commands/importcldr.py
@@ -0,0 +1,221 @@
+import sys
+import os
+import re
+from optparse import make_option, OptionParser
+
+from django.core.management.base import LabelCommand, CommandError
+
+try:
+    from lxml import etree
+except ImportError:
+    raise CommandError('You need to install `python-lxml` to run this script')
+
+FORMATS_FILE_NAME = 'formats.py'
+FORMATS_FILE_HEADER = '''# -*- encoding: utf-8 -*-
+# This file is distributed under the same license as the Django package.
+#
+
+'''
+
+def quote(nodes, name,  locale, previous):
+    if len(nodes):
+        return "'%s'" % unicode(nodes[0].text).replace("'", "\\'")
+    else:
+        return None
+
+def convert_time(nodes, name,  locale, previous):
+    SPECIAL_CHARS = ('a', 'A', 'b', 'B', 'd', 'D', 'f', 'F', 'g', 'G', 'h',
+        'H', 'i', 'I', 'j', 'l', 'L', 'm', 'M', 'n', 'N', 'O', 'P', 'r',
+        's', 'S', 't', 'T', 'U', 'w', 'W', 'y', 'Y', 'z', 'Z')
+    FORMAT_STR_MAP = ( # not using a dict, because we have to apply formats in order
+        ('dd', 'd'),
+        ('d', 'j'),
+        ('MMMM', 'F'),
+        ('MMM', 'M'),
+        ('MM', 'm'),
+        ('M', 'n'),
+        ('yyyy', 'Y'),
+        ('yy', 'y'),
+        ('y', 'Y'),
+        ('hh', 'h'),
+        ('h', 'g'),
+        ('HH', 'H'),
+        ('H', 'G'),
+        ('mm', 'i'),
+        ('ss', 's'),
+        ('a', 'A'),
+        ('LLLL', 'F'),
+    )
+    if len(nodes):
+        original = nodes[0].text
+        result = ''
+        for cnt, segment in enumerate(original.split("'")):
+            if cnt % 2:
+                for char in SPECIAL_CHARS:
+                    segment = segment.replace(char, '\\%s' % char)
+                result += segment
+            else:
+                while segment:
+                    found = False
+                    for src, dst in FORMAT_STR_MAP:
+                        if segment[0:len(src)] == src:
+                            result += dst
+                            segment = segment[len(src):]
+                            found = True
+                            break
+                    if not found:
+                        result += segment[0]
+                        segment = segment[1:]
+
+        return "'%s'" % result
+    else:
+        return None
+
+def datetime(nodes, name, locale, previous):
+    result = None
+    if len(nodes) and 'DATE_FORMAT' in previous and 'TIME_FORMAT' in previous:
+        result = nodes[0].text
+        result = result.replace('{0}', previous['TIME_FORMAT'][1:-1])
+        if name == 'SHORT_DATETIME_FORMAT' and 'SHORT_DATE_FORMAT' in previous:
+            result = result.replace('{1}', previous['SHORT_DATE_FORMAT'][1:-1])
+        else:
+            result = result.replace('{1}', previous['DATE_FORMAT'][1:-1])
+    if result:
+        return "'%s'" % result
+    else:
+        return None
+
+FORMATS_MAP = [
+    {
+        'name': 'DATE_FORMAT',
+        'file': os.path.join('common', 'main', '%(locale)s.xml'),
+        'pattern': "/ldml/dates/calendars/calendar[@type='gregorian']/dateFormats/dateFormatLength[@type='long']/dateFormat/pattern",
+        'conversion': convert_time,
+    },
+    {
+        'name': 'TIME_FORMAT',
+        'file': os.path.join('common', 'main', '%(locale)s.xml'),
+        'pattern': "/ldml/dates/calendars/calendar[@type='gregorian']/timeFormats/timeFormatLength[@type='medium']/timeFormat/pattern",
+        'conversion': convert_time,
+    },
+    {
+        'name': 'DATETIME_FORMAT',
+        'file': os.path.join('common', 'main', '%(locale)s.xml'),
+        'pattern': "/ldml/dates/calendars/calendar[@type='gregorian']/dateTimeFormats/dateTimeFormatLength[@type='long']/dateTimeFormat/pattern",
+        'conversion': datetime,
+    },
+    {
+        'name': 'YEAR_MONTH_FORMAT',
+        'file': os.path.join('common', 'main', '%(locale)s.xml'),
+        'pattern': "/ldml/dates/calendars/calendar[@type='gregorian']/dateTimeFormats/availableFormats/dateFormatItem[@id='yMMMM']",
+        'conversion': convert_time,
+    },
+    {
+        'name': 'MONTH_DAY_FORMAT',
+        'file': os.path.join('common', 'main', '%(locale)s.xml'),
+        'pattern': "/ldml/dates/calendars/calendar[@type='gregorian']/dateTimeFormats/availableFormats/dateFormatItem[@id='MMMMd']",
+        'conversion': convert_time,
+    },
+    {
+        'name': 'SHORT_DATE_FORMAT',
+        'file': os.path.join('common', 'main', '%(locale)s.xml'),
+        'pattern': "/ldml/dates/calendars/calendar[@type='gregorian']/dateFormats/dateFormatLength[@type='medium']/dateFormat/pattern",
+        'conversion': convert_time,
+    },
+    {
+        'name': 'SHORT_DATETIME_FORMAT',
+        'file': os.path.join('common', 'main', '%(locale)s.xml'),
+        'pattern': "/ldml/dates/calendars/calendar[@type='gregorian']/dateTimeFormats/dateTimeFormatLength[@type='short']/dateTimeFormat/pattern",
+        'conversion': datetime,
+    },
+    {'name': 'FIRST_DAY_OF_WEEK'},
+    {'name': 'DATE_INPUT_FORMATS'},
+    {'name': 'TIME_INPUT_FORMATS'},
+    {'name': 'DATETIME_INPUT_FORMATS'},
+    {
+        'name': 'DECIMAL_SEPARATOR',
+        'file': os.path.join('common', 'main', '%(locale)s.xml'),
+        'pattern': "/ldml/numbers/symbols/decimal",
+        'conversion': quote,
+    },
+    {
+        'name': 'THOUSAND_SEPARATOR',
+        'file': os.path.join('common', 'main', '%(locale)s.xml'),
+        'pattern': "/ldml/numbers/symbols/group",
+        'conversion': quote,
+    },
+    {'name': 'NUMBER_GROUPING'},
+]
+"""
+"""
+
+def get_locales(django_locale_dir, locale=None):
+    if locale:
+        yield locale
+    else:
+        locale_re = re.compile('[a-z]{2}(_[A-Z]{2})?')
+        for locale in os.listdir(django_locale_dir):
+            if locale_re.match(locale):
+                yield locale
+
+def import_cldr(cldr_dir, locale=None, overwrite=False):
+    """
+    For every locale defined in Django, get from the CLDR locale file all
+    settings defined in output_structure, and write the result to the 
+    locale directories on Django.
+    """
+    if not os.path.isdir(cldr_dir):
+        raise Exception, "Specified CLDR directory '%s' does not exist" % cldr_dir
+
+    import django
+    django_locale_dir = os.path.join(os.path.dirname(django.__file__), 'conf', 'locale')
+
+    for locale in get_locales(django_locale_dir, locale):
+        output_filename = os.path.join(django_locale_dir, locale, FORMATS_FILE_NAME)
+        if os.path.isfile(output_filename) and not overwrite:
+            print "'%s' locale already exists. Skipping" % locale
+        else:
+            result = {}
+            output_file = open(output_filename, 'w')
+            output_file.write(FORMATS_FILE_HEADER)
+            for format in FORMATS_MAP:
+                if 'file' in format:
+                    cldr_file = os.path.join(cldr_dir, format['file'] % dict(locale=locale))
+                    tree = etree.parse(cldr_file) # TODO: error control
+                    try:
+                        original_value = tree.xpath(format['pattern'])
+                    except IndexError:
+                        output_file.write('# %s = \n' % (format['name']))
+                    else:
+                        value = format['conversion'](original_value, format['name'], locale, result)
+                        if value:
+                            output_file.write('%s = %s\n' % (format['name'], value.encode('utf8')))
+                            result[format['name']] = value
+                        else:
+                            output_file.write('# %s = \n' % (format['name']))
+                else:
+                    output_file.write('# %s = \n' % (format['name']))
+            output_file.close()
+
+            init_filename = os.path.join(django_locale_dir, locale, '__init__.py')
+            open(init_filename, 'a').close()
+
+class Command(LabelCommand):
+    option_list = LabelCommand.option_list + (
+        make_option('--locale', '-l', dest='locale',
+            help='The locale to process. Default is to process all.'),
+    ) + (
+        make_option('--overwite', '-o', action='store_true', dest='overwrite',
+            help='Wheter to overwrite format definitions of locales that already have one.'),
+    )
+    help = 'Creates format definition files for locales, importing data from the CLDR.'
+    args = '[cldrpath]'
+    label = 'CLDR path'
+    requires_model_validation = False
+    can_import_settings = False
+
+    def handle_label(self, cldrpath, **options):
+        locale = options.get('locale')
+        overwrite = options.get('overwrite')
+        import_cldr(cldrpath, locale, overwrite)
+
diff --git a/django/forms/extras/widgets.py b/django/forms/extras/widgets.py
index e36b8a1..04ad24d 100644
--- a/django/forms/extras/widgets.py
+++ b/django/forms/extras/widgets.py
@@ -8,6 +8,8 @@ import re
 from django.forms.widgets import Widget, Select
 from django.utils.dates import MONTHS
 from django.utils.safestring import mark_safe
+from django.utils.formats import getformat
+from django.conf import settings
 
 __all__ = ('SelectDateWidget',)
 
@@ -45,38 +47,27 @@ class SelectDateWidget(Widget):
                 if match:
                     year_val, month_val, day_val = [int(v) for v in match.groups()]
 
-        output = []
-
-        if 'id' in self.attrs:
-            id_ = self.attrs['id']
-        else:
-            id_ = 'id_%s' % name
-
-        month_choices = MONTHS.items()
-        if not (self.required and value):
-            month_choices.append(self.none_value)
-        month_choices.sort()
-        local_attrs = self.build_attrs(id=self.month_field % id_)
-        s = Select(choices=month_choices)
-        select_html = s.render(self.month_field % name, month_val, local_attrs)
-        output.append(select_html)
-
-        day_choices = [(i, i) for i in range(1, 32)]
-        if not (self.required and value):
-            day_choices.insert(0, self.none_value)
-        local_attrs['id'] = self.day_field % id_
-        s = Select(choices=day_choices)
-        select_html = s.render(self.day_field % name, day_val, local_attrs)
-        output.append(select_html)
-
-        year_choices = [(i, i) for i in self.years]
-        if not (self.required and value):
-            year_choices.insert(0, self.none_value)
-        local_attrs['id'] = self.year_field % id_
-        s = Select(choices=year_choices)
-        select_html = s.render(self.year_field % name, year_val, local_attrs)
-        output.append(select_html)
+        choices = [(i, i) for i in self.years]
+        year_html = self.create_select(name, self.year_field, value, year_val, choices)
+        choices = MONTHS.items()
+        month_html = self.create_select(name, self.month_field, value, month_val, choices)
+        choices = [(i, i) for i in range(1, 32)]
+        day_html = self.create_select(name, self.day_field, value, day_val,  choices)
 
+        format = getformat('DATE_FORMAT')
+        escaped = False
+        output = []
+        for char in format:
+            if escaped:
+                escaped = False
+            elif char == '\\':
+                escaped = True
+            elif char in 'Yy':
+                output.append(year_html)
+            elif char in 'bFMmNn':
+                output.append(month_html)
+            elif char in 'dj':
+                output.append(day_html)
         return mark_safe(u'\n'.join(output))
 
     def id_for_label(self, id_):
@@ -90,5 +81,27 @@ class SelectDateWidget(Widget):
         if y == m == d == "0":
             return None
         if y and m and d:
-            return '%s-%s-%s' % (y, m, d)
+            if settings.USE_FORMAT_I18N:
+                input_format = getformat('DATE_INPUT_FORMATS')[0]
+                try:
+                    date_value = datetime.date(int(y), int(m), int(d))
+                except ValueError:
+                    pass
+                else:
+                    return date_value.strftime(input_format)
+            else:
+                return '%s-%s-%s' % (y, m, d)
         return data.get(name, None)
+
+    def create_select(self, name, field, value, val, choices):
+        if 'id' in self.attrs:
+            id_ = self.attrs['id']
+        else:
+            id_ = 'id_%s' % name
+        if not (self.required and value):
+            choices.insert(0, self.none_value)
+        local_attrs = self.build_attrs(id=field % id_)
+        s = Select(choices=choices)
+        select_html = s.render(field % name, val, local_attrs)
+        return select_html
+
diff --git a/django/forms/fields.py b/django/forms/fields.py
index c0ee2f0..6009096 100644
--- a/django/forms/fields.py
+++ b/django/forms/fields.py
@@ -17,15 +17,14 @@ import django.core.exceptions
 import django.utils.copycompat as copy
 from django.utils.translation import ugettext_lazy as _
 from django.utils.encoding import smart_unicode, smart_str
+from django.utils.formats import getformat
 
 from util import ErrorList, ValidationError
 from widgets import TextInput, PasswordInput, HiddenInput, MultipleHiddenInput, FileInput, CheckboxInput, Select, NullBooleanSelect, SelectMultiple, DateInput, DateTimeInput, TimeInput, SplitDateTimeWidget, SplitHiddenDateTimeWidget
 
 __all__ = (
     'Field', 'CharField', 'IntegerField',
-    'DEFAULT_DATE_INPUT_FORMATS', 'DateField',
-    'DEFAULT_TIME_INPUT_FORMATS', 'TimeField',
-    'DEFAULT_DATETIME_INPUT_FORMATS', 'DateTimeField', 'TimeField',
+    'DateField', 'TimeField', 'DateTimeField', 'TimeField',
     'RegexField', 'EmailField', 'FileField', 'ImageField', 'URLField',
     'BooleanField', 'NullBooleanField', 'ChoiceField', 'MultipleChoiceField',
     'ComboField', 'MultiValueField', 'FloatField', 'DecimalField',
@@ -200,7 +199,9 @@ class FloatField(Field):
         if not self.required and value in EMPTY_VALUES:
             return None
         try:
-            value = float(value)
+            # We always accept dot as decimal separator
+            if isinstance(value, str) or isinstance(value, unicode):
+                value = float(value.replace(getformat('DECIMAL_SEPARATOR'), '.'))
         except (ValueError, TypeError):
             raise ValidationError(self.error_messages['invalid'])
         if self.max_value is not None and value > self.max_value:
@@ -236,7 +237,9 @@ class DecimalField(Field):
             return None
         value = smart_str(value).strip()
         try:
-            value = Decimal(value)
+            # We always accept dot as decimal separator
+            if isinstance(value, str) or isinstance(value, unicode):
+                value = Decimal(value.replace(getformat('DECIMAL_SEPARATOR'), '.'))
         except DecimalException:
             raise ValidationError(self.error_messages['invalid'])
 
@@ -264,14 +267,6 @@ class DecimalField(Field):
             raise ValidationError(self.error_messages['max_whole_digits'] % (self.max_digits - self.decimal_places))
         return value
 
-DEFAULT_DATE_INPUT_FORMATS = (
-    '%Y-%m-%d', '%m/%d/%Y', '%m/%d/%y', # '2006-10-25', '10/25/2006', '10/25/06'
-    '%b %d %Y', '%b %d, %Y',            # 'Oct 25 2006', 'Oct 25, 2006'
-    '%d %b %Y', '%d %b, %Y',            # '25 Oct 2006', '25 Oct, 2006'
-    '%B %d %Y', '%B %d, %Y',            # 'October 25 2006', 'October 25, 2006'
-    '%d %B %Y', '%d %B, %Y',            # '25 October 2006', '25 October, 2006'
-)
-
 class DateField(Field):
     widget = DateInput
     default_error_messages = {
@@ -280,7 +275,7 @@ class DateField(Field):
 
     def __init__(self, input_formats=None, *args, **kwargs):
         super(DateField, self).__init__(*args, **kwargs)
-        self.input_formats = input_formats or DEFAULT_DATE_INPUT_FORMATS
+        self.input_formats = input_formats
 
     def clean(self, value):
         """
@@ -294,18 +289,13 @@ class DateField(Field):
             return value.date()
         if isinstance(value, datetime.date):
             return value
-        for format in self.input_formats:
+        for format in self.input_formats or getformat('DATE_INPUT_FORMATS'):
             try:
                 return datetime.date(*time.strptime(value, format)[:3])
             except ValueError:
                 continue
         raise ValidationError(self.error_messages['invalid'])
 
-DEFAULT_TIME_INPUT_FORMATS = (
-    '%H:%M:%S',     # '14:30:59'
-    '%H:%M',        # '14:30'
-)
-
 class TimeField(Field):
     widget = TimeInput
     default_error_messages = {
@@ -314,7 +304,7 @@ class TimeField(Field):
 
     def __init__(self, input_formats=None, *args, **kwargs):
         super(TimeField, self).__init__(*args, **kwargs)
-        self.input_formats = input_formats or DEFAULT_TIME_INPUT_FORMATS
+        self.input_formats = input_formats
 
     def clean(self, value):
         """
@@ -326,25 +316,13 @@ class TimeField(Field):
             return None
         if isinstance(value, datetime.time):
             return value
-        for format in self.input_formats:
+        for format in self.input_formats or getformat('TIME_INPUT_FORMATS'):
             try:
                 return datetime.time(*time.strptime(value, format)[3:6])
             except ValueError:
                 continue
         raise ValidationError(self.error_messages['invalid'])
 
-DEFAULT_DATETIME_INPUT_FORMATS = (
-    '%Y-%m-%d %H:%M:%S',     # '2006-10-25 14:30:59'
-    '%Y-%m-%d %H:%M',        # '2006-10-25 14:30'
-    '%Y-%m-%d',              # '2006-10-25'
-    '%m/%d/%Y %H:%M:%S',     # '10/25/2006 14:30:59'
-    '%m/%d/%Y %H:%M',        # '10/25/2006 14:30'
-    '%m/%d/%Y',              # '10/25/2006'
-    '%m/%d/%y %H:%M:%S',     # '10/25/06 14:30:59'
-    '%m/%d/%y %H:%M',        # '10/25/06 14:30'
-    '%m/%d/%y',              # '10/25/06'
-)
-
 class DateTimeField(Field):
     widget = DateTimeInput
     default_error_messages = {
@@ -353,7 +331,7 @@ class DateTimeField(Field):
 
     def __init__(self, input_formats=None, *args, **kwargs):
         super(DateTimeField, self).__init__(*args, **kwargs)
-        self.input_formats = input_formats or DEFAULT_DATETIME_INPUT_FORMATS
+        self.input_formats = input_formats
 
     def clean(self, value):
         """
@@ -373,7 +351,7 @@ class DateTimeField(Field):
             if len(value) != 2:
                 raise ValidationError(self.error_messages['invalid'])
             value = '%s %s' % tuple(value)
-        for format in self.input_formats:
+        for format in self.input_formats or getformat('DATETIME_INPUT_FORMATS'):
             try:
                 return datetime.datetime(*time.strptime(value, format)[:6])
             except ValueError:
diff --git a/django/forms/widgets.py b/django/forms/widgets.py
index d59e634..aabd1b0 100644
--- a/django/forms/widgets.py
+++ b/django/forms/widgets.py
@@ -10,6 +10,7 @@ from django.utils.html import escape, conditional_escape
 from django.utils.translation import ugettext
 from django.utils.encoding import StrAndUnicode, force_unicode
 from django.utils.safestring import mark_safe
+from django.utils.formats import localize
 from django.utils import datetime_safe
 from datetime import time
 from util import flatatt
@@ -208,7 +209,7 @@ class Input(Widget):
         final_attrs = self.build_attrs(attrs, type=self.input_type, name=name)
         if value != '':
             # Only add the 'value' attribute if a value is non-empty.
-            final_attrs['value'] = force_unicode(value)
+            final_attrs['value'] = force_unicode(localize(value, is_input=True))
         return mark_safe(u'<input%s />' % flatatt(final_attrs))
 
 class TextInput(Input):
diff --git a/django/utils/formats.py b/django/utils/formats.py
new file mode 100644
index 0000000..51737b2
--- /dev/null
+++ b/django/utils/formats.py
@@ -0,0 +1,97 @@
+import decimal
+import datetime
+
+from django.conf import settings
+from django.utils.translation import get_language, to_locale, check_for_language
+from django.utils.importlib import import_module
+from django.utils import dateformat
+from django.utils import numberformat
+
+def get_format_modules():
+    """
+    Returns an iterator over the format modules found in the project and Django
+    """
+    modules = []
+    if not check_for_language(get_language()):
+        return modules
+    locale = to_locale(get_language())
+    if settings.FORMAT_MODULE_PATH:
+        format_locations = [settings.FORMAT_MODULE_PATH + '.%s']
+    else:
+        format_locations = []
+    format_locations.append('django.conf.locale.%s')
+    for location in format_locations:
+        for l in (locale, locale.split('_')[0]):
+            try:
+                mod = import_module('.formats', location % l)
+            except ImportError:
+                pass
+            else:
+                # Don't return duplicates
+                if mod not in modules:
+                    modules.append(mod)
+    return modules
+
+def getformat(format_type):
+    """
+    For a specific format type, returns the format for the
+    current language (locale) defaulting to the format on settings.
+    format_type is the name of the format, for example 'DATE_FORMAT'
+    """
+    if settings.USE_I18N and settings.USE_FORMAT_I18N:
+        for module in get_format_modules():
+            try:
+                return getattr(module, format_type)
+            except AttributeError:
+                pass
+    return getattr(settings, format_type)
+
+def date_format(value, format=None):
+    """
+    Formats a datetime.date or datetime.datetime object using a
+    localizable format
+    """
+    return dateformat.format(value, getformat(format or 'DATE_FORMAT'))
+
+def number_format(value, decimal_pos=None):
+    """
+    Formats a numeric value using localization settings
+    """
+    return numberformat.format(
+        value,
+        getformat('DECIMAL_SEPARATOR'),
+        decimal_pos,
+        getformat('NUMBER_GROUPING'),
+        getformat('THOUSAND_SEPARATOR'),
+    )
+
+def localize(value, is_input=False):
+    """
+    Checks value, and if it has a localizable type (date,
+    number...) it returns the value as a string using
+    current locale format
+    """
+    if settings.USE_I18N and settings.USE_FORMAT_I18N:
+        if isinstance(value, decimal.Decimal):
+            return number_format(value)
+        elif isinstance(value, float):
+            return number_format(value)
+        elif isinstance(value, int):
+            return number_format(value)
+        elif isinstance(value, datetime.datetime):
+            if not is_input:
+                return date_format(value, 'DATETIME_FORMAT')
+            else:
+                return value.strftime(getformat('DATETIME_INPUT_FORMATS')[0])
+        elif isinstance(value, datetime.date):
+            if not is_input:
+                return date_format(value)
+            else:
+                return value.strftime(getformat('DATE_INPUT_FORMATS')[0])
+        elif isinstance(value, datetime.time):
+            if not is_input:
+                return date_format(value, 'TIME_FORMAT')
+            else:
+                return value.strftime(getformat('TIME_INPUT_FORMATS')[0])
+    return value
+
diff --git a/django/utils/numberformat.py b/django/utils/numberformat.py
new file mode 100644
index 0000000..78ecb2f
--- /dev/null
+++ b/django/utils/numberformat.py
@@ -0,0 +1,42 @@
+from django.conf import settings
+
+def format(number, decimal_sep, decimal_pos, grouping=0, thousand_sep=''):
+    """
+    Gets a number (as a number or string), and returns it as a string,
+    using formats definied as arguments:
+
+    * decimal_sep: Decimal separator symbol (for example ".")
+    * decimal_pos: Number of decimal positions
+    * grouping: Number of digits in every group limited by thousand separator
+    * thousand_sep: Thousand separator symbol (for example ",")
+
+    """
+    # sign
+    if float(number) < 0:
+        sign = '-'
+    else:
+        sign = ''
+    # decimal part
+    str_number = unicode(number)
+    if str_number[0] == '-':
+        str_number = str_number[1:]
+    if '.' in str_number:
+        int_part, dec_part = str_number.split('.')
+        if decimal_pos:
+            dec_part = dec_part[:decimal_pos]
+    else:
+        int_part, dec_part = str_number, ''
+    if decimal_pos:
+        dec_part = dec_part + ('0' * (decimal_pos - len(dec_part)))
+    if dec_part: dec_part = decimal_sep + dec_part
+    # grouping
+    if settings.USE_THOUSAND_SEPARATOR and grouping:
+        int_part_gd = ''
+        for cnt, digit in enumerate(int_part[::-1]):
+            if cnt and not cnt % grouping:
+                int_part_gd += thousand_sep
+            int_part_gd += digit
+        int_part = int_part_gd[::-1]
+
+    return sign + int_part + dec_part
+
diff --git a/django/utils/translation/trans_null.py b/django/utils/translation/trans_null.py
index 98c6de6..50f41a2 100644
--- a/django/utils/translation/trans_null.py
+++ b/django/utils/translation/trans_null.py
@@ -2,6 +2,7 @@
 # that don't actually do anything. This is purely for performance, so that
 # settings.USE_I18N = False can use this module rather than trans_real.py.
 
+import warnings
 from django.conf import settings
 from django.utils.encoding import force_unicode
 from django.utils.safestring import mark_safe, SafeData
@@ -18,10 +19,10 @@ activate = lambda x: None
 deactivate = deactivate_all = lambda: None
 get_language = lambda: settings.LANGUAGE_CODE
 get_language_bidi = lambda: settings.LANGUAGE_CODE in settings.LANGUAGES_BIDI
-get_date_formats = lambda: (settings.DATE_FORMAT, settings.DATETIME_FORMAT, settings.TIME_FORMAT)
-get_partial_date_formats = lambda: (settings.YEAR_MONTH_FORMAT, settings.MONTH_DAY_FORMAT)
 check_for_language = lambda x: True
 
+# date formats shouldn't be used using gettext anymore. This
+# is kept for backward compatibility
 TECHNICAL_ID_MAP = {
     "DATE_WITH_TIME_FULL": settings.DATETIME_FORMAT,
     "DATE_FORMAT": settings.DATE_FORMAT,
@@ -51,3 +52,21 @@ def to_locale(language):
 
 def get_language_from_request(request):
     return settings.LANGUAGE_CODE
+
+# get_date_formats and get_partial_date_formats aren't used anymore by Django
+# but are kept for backward compatibility.
+def get_date_formats():
+    warnings.warn(
+        '`django.utils.translation.get_date_formats` is deprecated. '
+        'Please update your code to use the new i18n aware formatting.',
+        PendingDeprecationWarning
+    )
+    return settings.DATE_FORMAT, settings.DATETIME_FORMAT, settings.TIME_FORMAT
+
+def get_partial_date_formats():
+    warnings.warn(
+        '`django.utils.translation.get_partial_date_formats` is deprecated. '
+        'Please update your code to use the new i18n aware formatting.',
+        PendingDeprecationWarning
+    )
+    return settings.YEAR_MONTH_FORMAT, settings.MONTH_DAY_FORMAT
